<html>
<head>
    <title>zeroToHero - backed - feladat 1</title>
    <style>
        body {
            margin: 32px;
            font-family: sans-serif;
            font-size: 16px;
        }
        
        h1 {
            color: #101010;
            font-family: sans-serif;
            font-size: 28px;
            font-weight: bold;
        }
        
        .content {
            width: 1200px;
            margin-left: auto;
            margin-right: auto;
            margin-top: 24px;
            padding: 16px;
            background-color: #F0F0F0;
            color: #303030;
            border: 1px solid #E0E0E0;
            border-radius: 8px;
        }
        
        .feladat-leiras {
            font-size: 20px;
            white-space: pre;
            padding: 8px;
            background-color: #E0E0E0;
            border: 1px solid #D0D0D0;
            border-radius: 8px;
            margin-top: 8px;
            margin-bottom: 8px;
        }
        
        .feladatok {
            white-space: pre;
        }
    </style>
</head>
<body>
<div class="content">
<h1>Üdvözöllek a <i>zeroToHero</i> fejlesztői verseny <i>backend</i> kategória <u>első feladatában</u></h1> 
<hr>
<div class="feladat-leiras">A csatolt program egy sprint boot alkalmazás, mely tartalmaz egy Person entitást, 
melyet JPA-val kezelünk egy in-memory adatbázisban.
    
Bővítsd az alkalmazást a következő elvárásoknak megfelelően:
</div>
<div class="feladatok">
• Az alkalmazás indulásnál mentsen el 3 szabadon választott adatokkal létrehozott Person entitást automatikusan.

• A Person entitáshoz tartozhasson 1 vagy több Contact entitás, mely a következő mezőket kell, hogy tartalmazza:
        o country: string
        o city: string
        o postalCode: string
        o address: string

• Hozz létre Person CRUD műveleteket végrehajtó REST szervízt (json visszatérési értékekkel). Új entitás esetén az id automatikusan generált érték legyen.

• Hozz létre REST szervízt egy adott Person -hoz tartozó Contact -ok kezelésére

• Kössük be a következő bean validation szabályokat és oldjuk meg a hiba kezelést egy saját json üzenettel, mely tartalmazzon egy státusz kódot és a hibákat,
    azaz mely mező milyen megszorítást sértett:
        o Person.firstName és Person.lastName minimum 3 karakter hosszú legyen
        o Contact entitás minden mezöje legyen kötelező és egyik sem lehet üres, a postalCode pedig legyen minimum 4 karakter hosszú

• Javítsuk a Person és Contact entitásokat
        o Absztrakció
        o Szerializáció
        o Összehasonlíthatóság
        o Konkurenciatűrés
            OptimisticLockException elleni védelem
</div>
</div>
</body>
</html>